module Dag
  class Client

    autoload :API,               'dag/client/api'
    autoload :Cluster,           'dag/client/cluster'
    autoload :ClusterValidation, 'dag/client/cluster_validation'
    autoload :Database,          'dag/client/database'
    autoload :Job,               'dag/client/job'
    autoload :JobValidation,     'dag/client/job_validation'
    autoload :Storage,           'dag/client/storage'
    autoload :Table,             'dag/client/table'

    def initialize(apikey, secret, options = {})
      @api = API.new(apikey, secret, options)
    end

    attr_reader :api

    def apikey
      @api.apikey
    end

    def analysis_api
      @api.analysis_api
    end

    def storage_api
      @api.storage_api
    end

    include Dag::Client::Database
    include Dag::Client::Cluster
    include Dag::Client::Job
    include Dag::Client::Storage
  end
end
