module Dag
  class BucketCollection < Model
    include Enumerable

    def create(bucket_name)
      @api.create_bucket(bucket_name)
      bucket_named(bucket_name)
    end

    # @example
    #
    #   bucket = client.buckets[:mybucket],
    #   bucket = client.buckets['mybucket'],
    #
    # @param [String] bucket_name
    # @return [Bucket]
    def [] bucket_name
      bucket_named(bucket_name)
    end

    def each
      buckets = @api.buckets.buckets
      buckets.each do |bucket|
        yield bucket_named(bucket)
      end
    end

    private

    def bucket_named(bucket)
      Dag::Bucket.new(@api, bucket.to_s)
    end
  end
end
