module Dag
  class Database < Model
    def initialize(api, cluster_name, db_name, cluster_status: nil)
      super(api)

      @cluster_name = cluster_name
      @cluster_status = cluster_status
      @db_name = db_name
      @name = @db_name
    end

    attr_reader :cluster_name, :db_name, :name

    def delete
      @api.delete_database(@cluster_name, @name)
    end

    #
    # == parameters ==
    # * <tt>label</tt> - label
    # * <tt>input_object_keys</tt> - array of object_keys. ex ["#{bucket}/${big_object1}", "#{bucket}/${big_object2}"]
    # * <tt>input_format</tt> - 'csv' or 'tsv' or 'json'
    # * <tt>schema</tt> - schema
    def split(tbl_name, params)
      split_info = @api.split_table(@cluster_name, @db_name, tbl_name, params)
      job_id = split_info['queryId']

      query_info = @api.query_info(job_id)
      Dag::Job.new(@api, query_info)
    end

    include Dag::Client::Table
  end
end
