module Dag
  class Client
    module Table
      def tables
        Dag::TableCollection.new(@api, @cluster_name, @db_name)
      end

      def table(tbl_name)
        unless table_info = @api.table(@cluster_name, @db_name, tbl_name)
          raise Dag::Client::TableNotFound.new('table not found')
        end
        Dag::Table.new(@api, @cluster_name, @db_name, params: table_info)
      end
    end
  end
end
